#include <stdio.h>
#include <math.h>
#include <GL/glut.H>

//_ƒ_W̔z (̓t@Cǂ񂾎Ɋmۍς)
int verN;
float (*ver)[3];

//Op`ƎOp`̒_ԍ̔z (̓t@Cǂ񂾎Ɋmۍς)
int triN;
int (*tri)[3];

//Op`̖@ (TCY triN ~ 3)
//ۑ2-2ŌvZ (̓t@Cǂ񂾎Ɋmۍς)
float (*norT)[3];

//_̖@ (TCY verN ~ 3)
//ۑ2-3ŌvZ (̓t@Cǂ񂾎Ɋmۍς)
float (*norV)[3];

//vVA (TCY verN ~ 3)
//ۑ3 ŌvZ (̓t@Cǂ񂾎Ɋmۍς)
float (*lap)[3];
//אڒ_𐔂邽߂̔z
int *neiN;


//ۑ2-2 : Op`̖@vZ֐
void computeTriangleNormals(){
  for(int i=0; i<triN; i++){
    //z̓YȂ̂ŕϐɑĂ
    int* t = tri[i];
    float* A = ver[ t[0] ]; // A[0]  xWAA[1]  yWAA[2]  zWɂȂ
    float* B = ver[ t[1] ];
    float* C = ver[ t[2] ];
    
    //ۑ͈ȉ߂
    //xNg AB  xNg AC ̊O
    float cx = (B[1]-A[1])*(C[2]-A[2]) - (B[2]-A[2])*(C[1]-A[1]);
    float cy = (B[2]-A[2])*(C[0]-A[0]) - (B[0]-A[0])*(C[2]-A[2]);
    float cz = (B[0]-A[0])*(C[1]-A[1]) - (B[1]-A[1])*(C[0]-A[0]);
    
    //vZĐK
    float l = sqrt(cx*cx + cy*cy + cz*cz);
    if(l != 0){ //ZĖɂȂȂ悤ɂ
      norT[i][0] = cx/l;
      norT[i][1] = cy/l;
      norT[i][2] = cz/l;
    }
  }
}

//ۑ2-4 : _@vZ֐
void computeVertexNormals(){
  //ׂĂ̒_@[xNgɂ
  for(int i=0; i<verN; i++){
    norV[i][0] = 0;
    norV[i][1] = 0;
    norV[i][2] = 0;
  }
  
  //eOp`ɂ
  for(int i=0; i<triN; i++){
    int* t = tri[i];
    float* A = ver[t[0]];
    float* B = ver[t[1]];
    float* C = ver[t[2]];
    
     //Op`2ӂ̊OςvZ
    float cx = (B[1]-A[1])*(C[2]-A[2]) - (B[2]-A[2])*(C[1]-A[1]);
    float cy = (B[2]-A[2])*(C[0]-A[0]) - (B[0]-A[0])*(C[2]-A[2]);
    float cz = (B[0]-A[0])*(C[1]-A[1]) - (B[1]-A[1])*(C[0]-A[0]);
    
    //ꂽOσxNg̎Op`Ȃ3_̖@֑
    for(int j=0; j<3; j++){
      norV[t[j]][0] += cx;
      norV[t[j]][1] += cy;
      norV[t[j]][2] += cz;
    }
  }
  
  //ׂĂ̒_@𐳋K
  for(int i=0; i<verN; i++){
    float* n = norV[i];
    float l = (float)sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
    if(l != 0){
      n[0] /= l;
      n[1] /= l;
      n[2] /= l;
    }
  }
}

//ۑ 3-1 : vVǍvZ
void computeLaplacians(){
  //SĂ̒_ɂ
  //vVA lap[i][0], lap[i][1], lap[i][2] [ɂ
  //אڒ_ neiN[i] [ɂ
  for(int i=0; i<verN; i++){
    lap[i][0] = 0;
    lap[i][1] = 0;
    lap[i][2] = 0;
    neiN[i] = 0;
  }
  
  //eOp`ɂ
  for(int i=0; i<triN; i++){
    int* t = tri[i];
    float* A = ver[t[0]];
    float* B = ver[t[1]];
    float* C = ver[t[2]];
    
    //xNg AB  A ̃vVAɑ
    lap[t[0]][0] += B[0] - A[0];
    lap[t[0]][1] += B[1] - A[1];
    lap[t[0]][2] += B[2] - A[2];
    //A ̗אڒ_ 1 ₷
    neiN[t[0]] = neiN[t[0]] + 1;
    
    //xNg BC  B ̃vVAɑ
    lap[t[1]][0] += C[0] - B[0];
    lap[t[1]][1] += C[1] - B[1];
    lap[t[1]][2] += C[2] - B[2];
    //B ̗אڒ_ 1 ₷
    neiN[t[1]] = neiN[t[1]] + 1;
    
    //xNg CA  C ̃vVAɑ
    lap[t[2]][0] += A[0] - C[0];
    lap[t[2]][1] += A[1] - C[1];
    lap[t[2]][2] += A[2] - C[2];
    //C ̗אڒ_ 1 ₷
    neiN[t[2]] = neiN[t[2]] + 1;
  }
  
  //SĂ̒_ɂăvVAאڒ_Ŋ
  for(int i=0; i<verN; i++){
    lap[i][0] = lap[i][0] / neiN[i];
    lap[i][1] = lap[i][1] / neiN[i];
    lap[i][2] = lap[i][2] / neiN[i];
  }
}

//ۑ 3-2 : vVA
void laplacianSmoothing(){
  //vVAvZ
  computeLaplacians();
  
  //ۑ 3-3 ł͂̒l𕉂ɂĂ݂
  float dt = 0.5; //0`1̒l 
  
  //e_ dt ~ vVA𑫂 (𖄂߂̂ۑ 3-2)
  for(int i=0; i<verN; i++){
    ver[i][0] = ver[i][0] + dt*lap[i][0];
    ver[i][1] = ver[i][1] + dt*lap[i][1];
    ver[i][2] = ver[i][2] + dt*lap[i][2];
  }
}


/************ ͉̉ۑɂ͊֌ŴȂ֐ (݂ȂĂ悢) *****************/

//ϐ낢
int mouseX, mouseY;
float qw, qx, qy, qz;
float zoom;
float shiftX, shiftY;
bool wire, flat, smooth, cur;
int width, height;
float aveE; //ӂ̕ς̒ (ʂ̐FÂɎg)

//C[ŕ\
void drawWire(){
  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
  glDisable(GL_LIGHTING); //Cg OFF
  
  glColor3f(0.4, 0.4, 0.4);
  for(int i=0; i<triN; i++){
    int *t = tri[i];
    glBegin(GL_POLYGON);
      glVertex3fv(ver[t[0]]);
      glVertex3fv(ver[t[1]]);
      glVertex3fv(ver[t[2]]);
    glEnd();
  }
}

//tbgVF[fBO
void flatShading(){
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glShadeModel(GL_FLAT); 
  glEnable(GL_LIGHTING);
  
  for(int i=0; i<triN; i++){
    int *t = tri[i];
    glBegin(GL_POLYGON);
      glNormal3fv(norT[i]);
      glVertex3fv(ver[t[0]]);
      glVertex3fv(ver[t[1]]);
      glVertex3fv(ver[t[2]]);
    glEnd();
  }
}

//X[XVF[fBO
void smoothShading(){
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glShadeModel(GL_SMOOTH);  
  glEnable(GL_LIGHTING);
  
  for(int i=0; i<triN; i++){
    int *t = tri[i];
    glBegin(GL_POLYGON);
      glNormal3fv(norV[t[0]]);
      glVertex3fv(ver[t[0]]);
      glNormal3fv(norV[t[1]]);
      glVertex3fv(ver[t[1]]);
      glNormal3fv(norV[t[2]]);
      glVertex3fv(ver[t[2]]);
    glEnd();
  }
}

void curvature(){
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glShadeModel(GL_SMOOTH);  
  glDisable(GL_LIGHTING); //CgOFF
  
  for(int i=0; i<triN; i++){
    int *t = tri[i];
    glBegin(GL_POLYGON);
    for(int j=0; j<3; j++){
      float dot = lap[t[j]][0]*norV[t[j]][0] + lap[t[j]][1]*norV[t[j]][1] + lap[t[j]][2]*norV[t[j]][2];
      float c = -5.0*dot/aveE + 0.5; //F悭t悤ɒlL΂
      glColor3f(c, c, c);
      glVertex3fv(ver[t[j]]);
    }
    glEnd();
  }
}

void display(void){ 
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 
  glLoadIdentity();
  
  glTranslatef(shiftX, shiftY, 0);
  float s = (float)sqrt(qx*qx + qy*qy + qz*qz);
  if(s != 0)
    glRotatef(2.0f*(float)acos(qw)*180/3.1412f, qx/s, qy/s,qz/s);
  
  //bṼ_O
  if(wire)
    drawWire();
  if(flat)
    flatShading();
  else if(smooth)
    smoothShading();
  else if(cur)
    curvature();
  
  glFlush(); 
  glutSwapBuffers(); 
} 

void allocateMem(){
  ver =  new float[verN][3];
  tri = new int[triN][3];
  norV = new float[verN][3];
  norT = new float[triN][3];
  lap = new float[verN][3];
  neiN = new int[verN];
}

void deleteMesh(){
  delete[] ver;
  delete[] tri;
  delete[] norV;
  delete[] norT;
  delete[] lap;
  delete[] neiN;
}

void readMesh(char* file_name){
  /* Read the mesh file */
  FILE* in = fopen(file_name, "r");
  
  fscanf(in, "%d", &verN);
  fscanf(in, "%d", &triN);
  
  allocateMem();
  
  for(int i=0; i<verN; i++){
    float* v = ver[i];
    fscanf(in, "%f %f %f", &v[0], &v[1], &v[2]);
  }
  
  for(int i=0; i<triN; i++){
    int* t = tri[i];
    fscanf(in, "%d %d %d", &t[0], &t[1], &t[2]);
  }
  
  fclose(in);
}
  
void normalizeSize(float length){
  // Compute the bounding box
  float max[3], min[3];
  float size[3], mid[3];
  for(int i=0; i<3; i++){
    max[i] = ver[0][i];
    min[i] = ver[0][i];
    for(int j=1; j<verN; j++){
      float v = ver[j][i];
      if(v > max[i])
        max[i] = v;
      else if(v < min[i])
        min[i] = v;
    }
    size[i] = max[i] - min[i];
    mid[i] = 0.5f*(max[i] + min[i]);
  }
  
  float s = size[0];
  if(size[1] > s)
    s = size[1];
  if(size[2] > s)
    s = size[2];
  float scale = length/s;
  
  for(int i=0; i<3; i++)
    for(int j=0; j<verN; j++)
      ver[j][i] = scale*(ver[j][i] - mid[i]);
  
  //ӂ̕ς̒vZĂ
  double total = 0;
  for(int i=0; i<triN; i++){
    int* t = tri[i];
    for(int j=0; j<3; j++){
      float* p = ver[t[j]];
      float* q = ver[t[(j+1)%3]];
      total += sqrt((q[0]-p[0])*(q[0]-p[0]) + (q[1]-p[1])*(q[1]-p[1]) + (q[2]-p[2])*(q[2]-p[2]));
    }
  }
  aveE = total/(3*triN);
}

void myinit(){
  GLfloat mat_specular[]={0.5, 0.5, 0.5, 1.0};
  GLfloat mat_diffuse[]={0.5, 0.5, 1.0, 1.0};
  GLfloat mat_ambient[]={0.5, 0.5, 0.5, 1.0}; 
  GLfloat mat_shininess={20.0};
  GLfloat light_ambient[]={0.1, 0.1, 0.1, 1.0};
  GLfloat light_diffuse[]={1.0, 1.0, 1.0, 1.0};
  GLfloat light_specular[]={1.0, 1.0, 1.0, 1.0};
  
  /* set up ambient, diffuse, and specular components for light 0 */
  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
  
  /* define material proerties for front face of all polygons */
  glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
  glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
  glMaterialf(GL_FRONT, GL_SHININESS, mat_shininess);
  
  glShadeModel(GL_SMOOTH);   /* smooth shading */
  glEnable(GL_LIGHTING); /* enable lighting */
  glEnable(GL_LIGHT0);   /* enable light 0 */
  glEnable(GL_DEPTH_TEST); /* enable z buffer */
  glDepthFunc(GL_LEQUAL);
  
  glClearColor (1.0, 1.0, 1.0, 1.0);
}

void myReshape(int w, int h){
  width = w;
  height = h;
  
  glViewport(0, 0, w, h); 
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity(); 
  if (w <= h) 
    glOrtho(-2.0/zoom, 2.0/zoom,
            -2.0 * (GLfloat) h / (GLfloat) w /zoom, 
            2.0 * (GLfloat) h / (GLfloat) w /zoom,
            -10.0, 10.0); 
  else 
    glOrtho(-2.0 * (GLfloat) w / (GLfloat) h / zoom, 
            2.0 * (GLfloat) w / (GLfloat) h /zoom,
            -2.0/zoom, 2.0/zoom, -10.0, 10.0); 
  glMatrixMode(GL_MODELVIEW); 
} 

//}EX
void mouse(int btn, int state, int x, int y){ 
  if(state == GLUT_DOWN){
    mouseX = x;
    mouseY = y;
  }
  else if(btn==GLUT_LEFT_BUTTON){
    float mx = -0.0025f*(x - mouseX)/zoom;
    float my = 0.0025f*(y - mouseY)/zoom;
    
    //]
    float c = (float)cos(my);
    float s = (float)sin(my);
    
    float rw = c*qw - s*qx;
    float rx = c*qx + s*qw;
    float ry = c*qy - s*qz;
    float rz = c*qz + s*qy;
    
    c = (float)cos(mx);
    s = (float)sin(mx);
    
    qw = c*rw - s*ry;
    qx = c*rx + s*rz;
    qy = c*ry + s*rw;
    qz = c*rz - s*rx;
    
    float n = (float)sqrt(qw*qw + qx*qx + qy*qy + qz*qz);
    if(n != 0){
      qw /= n;
      qx /= n;
      qy /= n;
      qz /= n;
    }
    else{
      qw = 1.0f;
      qx = qy = qz = 0.0f;
    }
    display();
  }
  else if(btn==GLUT_RIGHT_BUTTON){ //gk
    zoom -= 0.0025f*(y - mouseY);
    if(zoom > 20.0f) zoom = 20.0f;
    else if(zoom < 0.05f) zoom = 0.05f;
    myReshape(width, height);
    display();
  }
  else if(btn==GLUT_MIDDLE_BUTTON){ //sړ
    shiftX += 0.0025f*(x - mouseX)/zoom;
    shiftY += 0.0025f*(y - mouseY)/zoom;
    display();
  }
} 

//L[ꂽɑΉ֐Ăяo
void keyboard(unsigned char key, int x, int y){
  switch (key) {
  case 'w':
    printf("C[\؂ւ\n");
    wire = !wire;
    display();
    break;
  case 'f':
    printf("tbgVF[fBO؂ւ\n");
    flat = !flat;
    if(flat){
      smooth = false;
      cur = false;
    }
    display();
    break;
  case 's':
    printf("X[XVF[fBO؂ւ\n");
    smooth = !smooth;
    if(smooth){
      flat = false;
      cur = false;
    }
    display();
    break;
  case 'l':
    printf("vVA\n");
    laplacianSmoothing();
    if(flat)
      computeTriangleNormals();
    else if(smooth)
      computeVertexNormals();
    else if(cur){
      computeVertexNormals();
      computeLaplacians();
    }
    display();
    break;
  case 'c':
    printf("ʕ\؂ւ\n");
    cur = !cur;
    if(cur){
      flat = false;
      smooth = false;
    }
    display();
    break;
  }
}


/**********************ȂƂ悢Ƃ낱܂***********************/

int main(int argc, char** argv){
  //ۑ 1-2 : FXbṼt@CςĂ݂
  //ۑ 1-3  2-3 : ōs~bh̃t@Cǂݍ
  //ǂݍ߂f[^ "round", "moai", "bunny", "hand", "dino", "igea", "armadillo"
  readMesh("data/bunny");
  
  normalizeSize(4); //bV̑傫Eɍ悤Ɋgk ( Ƃ͕ς)
  computeTriangleNormals(); //Op`@vZ
  computeVertexNormals(); //_@vZ
  computeLaplacians(); //vVAvZ
  
  //]Ȃǂ̏
  qw = 1;
  qx = qy =  qz = 0;
  zoom = 1;
  shiftX = shiftY = 0;
  wire = true;
  flat = false;
  cur = false;
  smooth = false;
  
  //EBhȄ
  glutInit(&argc, argv); 
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH); //gpobt@̐ݒ
  glutInitWindowSize(500, 500); //EBhȆ傫
  glutCreateWindow("prog3-1"); //EBhẼ^Cg
  
  myinit(); //OpenGL ̏
  glutReshapeFunc(myReshape); //EBhETCYύXꂽɌĂ΂֐ݒ
  glutDisplayFunc(display);  //EBhE̍XV̂߂̊֐ݒ
  glutMouseFunc(mouse); //}EX삳ꂽƂɌĂ΂֐ݒ
  glutKeyboardFunc(keyboard);//L[{[hꂽƂɌĂ΂֐ݒ
  
  glutMainLoop(); //C[v
  
  deleteMesh(); //*}[N̔zŎgĂ郁J
  
  return 0;
}

